## couchbase-cxx-client-1.2.1-1.jammy.x86_64.tar

=== tools/CMakeLists.txt ===
if(NOT TARGET CLI11::CLI11)
  # https://github.com/CLIUtils/CLI11/releases
  cpmaddpackage(
    NAME
    cli11
    VERSION
    2.5.0
    GITHUB_REPOSITORY
    "cliutils/cli11"
    OPTIONS
    "EXCLUDE_FROM_ALL ON"
    "BUILD_TESTING OFF"
    "CLI11_BUILD_TESTS OFF"
    "CLI11_BUILD_DOCS OFF"
    "CLI11_BUILD_EXAMPLES OFF"
    "CLI11_SINGLE_FILE_TESTS OFF"
    "CLI11_INSTALL OFF"
    "CLI11_PRECOMPILED ON")
endif()

add_executable(
  cbc
  cbc.cxx
  utils.cxx
  key_generator.cxx
  analytics.cxx
  beam.cxx
  get.cxx
  keygen.cxx
  pillowfight.cxx
  query.cxx
  remove.cxx
  upsert.cxx
  version.cxx)
target_include_directories(cbc PRIVATE ${PROJECT_SOURCE_DIR} ${PROJECT_SOURCE_DIR}/private)

set_project_warnings(cbc)
set_project_options(cbc)

target_link_libraries(
  cbc
  PRIVATE ${CMAKE_THREAD_LIBS_INIT}
          ${couchbase_cxx_client_DEFAULT_LIBRARY}
          $<BUILD_INTERFACE:CLI11>
          $<BUILD_INTERFACE:Microsoft.GSL::GSL>
          $<BUILD_INTERFACE:taocpp::json>
          $<BUILD_INTERFACE:spdlog::spdlog>
          $<BUILD_INTERFACE:hdr_histogram_static>
          $<BUILD_INTERFACE:asio>)
propagate_public_compile_definitions(cbc spdlog::spdlog asio)

if(COUCHBASE_CXX_CLIENT_STATIC_BORINGSSL AND WIN32)
  # Ignore the `LNK4099: PDB ['crypto.pdb'|'ssl.pdb'] was not found` warnings, as we don't (atm) keep track fo the *.PDB
  # from the BoringSSL build
  set_target_properties(cbc PROPERTIES LINK_FLAGS "/ignore:4099")
endif()

=== core/sasl/CMakeLists.txt ===
add_library(
  couchbase_sasl OBJECT
  client.cc
  context.cc
  mechanism.cc
  plain/plain.cc
  scram-sha/scram-sha.cc
  scram-sha/stringutils.cc)
set_target_properties(couchbase_sasl PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_include_directories(couchbase_sasl PRIVATE ../..)
set_project_warnings(couchbase_sasl)
set_project_options(couchbase_sasl)
target_link_libraries(couchbase_sasl PRIVATE Microsoft.GSL::GSL spdlog::spdlog)

=== third_party_cache/json/4c7c/json/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8...3.19)

project(taocpp-json VERSION 1.0.0 LANGUAGES CXX)

set(TAOCPP_JSON_IS_MAIN_PROJECT OFF)
if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  set(TAOCPP_JSON_IS_MAIN_PROJECT ON)
endif()

# installation directories
include(GNUInstallDirs)

set(TAOCPP_JSON_INSTALL_DOC_DIR "${CMAKE_INSTALL_DOCDIR}/tao/json" CACHE STRING "The installation doc directory")
set(TAOCPP_JSON_INSTALL_CMAKE_DIR "${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/cmake" CACHE STRING "The installation cmake directory")

# define a header-only library
add_library(taocpp-json INTERFACE)
add_library(taocpp::json ALIAS taocpp-json)
target_include_directories(taocpp-json INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

# require C++17
target_compile_features(taocpp-json INTERFACE cxx_std_17)

# find a suitable PEGTL
set(TAOCPP_JSON_PEGTL_MIN_VERSION 3.1.0)
find_package(pegtl ${TAOCPP_JSON_PEGTL_MIN_VERSION} QUIET CONFIG)
if(NOT pegtl_FOUND)
  # if a compatible version of PEGTL is not already installed, build and install it from the submodule directory
  message(STATUS "Adding PEGTL as submodule from external/PEGTL")
  set(PEGTL_INSTALL_INCLUDE_DIR ${CMAKE_INSTALL_INCLUDEDIR} CACHE STRING "Override PEGTL include install directory")
  set(PEGTL_INSTALL_CMAKE_DIR ${CMAKE_INSTALL_DATAROOTDIR}/pegtl/cmake CACHE STRING "Override PEGTL cmake install directory")
  add_subdirectory(external/PEGTL)
endif()

# add pegtl as a dependency
target_link_libraries(taocpp-json INTERFACE taocpp::pegtl)

# testing
option(TAOCPP_JSON_BUILD_TESTS "Build test programs" ${TAOCPP_JSON_IS_MAIN_PROJECT})
if(TAOCPP_JSON_BUILD_TESTS)
  enable_testing()
  add_subdirectory(src/test/json)
endif()

# examples
option(TAOCPP_JSON_BUILD_EXAMPLES "Build example programs" ${TAOCPP_JSON_IS_MAIN_PROJECT})
if(TAOCPP_JSON_BUILD_EXAMPLES)
  add_subdirectory(src/example/json)
endif()

option(TAOCPP_JSON_INSTALL "Generate the install target" ${TAOCPP_JSON_IS_MAIN_PROJECT})
if(TAOCPP_JSON_INSTALL)
  include(CMakePackageConfigHelpers)

  # Make package findable
  configure_package_config_file(.cmake/taocpp-json-config.cmake.in ${PROJECT_NAME}-config.cmake
    INSTALL_DESTINATION ${TAOCPP_JSON_INSTALL_CMAKE_DIR}
    NO_CHECK_REQUIRED_COMPONENTS_MACRO
    NO_SET_AND_CHECK_MACRO
  )

  # Ignore pointer width differences since this is a header-only library
  unset(CMAKE_SIZEOF_VOID_P)

  # Enable version checks in find_package
  write_basic_package_version_file(${PROJECT_NAME}-config-version.cmake COMPATIBILITY SameMajorVersion)

  # keep taocpp::json target compatibility
  set_target_properties(taocpp-json PROPERTIES EXPORT_NAME json)

  # install and export target
  install(TARGETS taocpp-json EXPORT ${PROJECT_NAME}-targets)
  install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
    DESTINATION ${TAOCPP_JSON_INSTALL_CMAKE_DIR}
  )
  install(EXPORT ${PROJECT_NAME}-targets
    NAMESPACE taocpp::
    DESTINATION ${TAOCPP_JSON_INSTALL_CMAKE_DIR}
  )

  install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
  install(FILES LICENSE DESTINATION ${TAOCPP_JSON_INSTALL_DOC_DIR})

  export(EXPORT ${PROJECT_NAME}-targets
    FILE ${taocpp-json_BINARY_DIR}/${PROJECT_NAME}-targets.cmake
    NAMESPACE taocpp::
  )
endif()

=== control ===
Source: couchbase-cxx-client
Section: libs
Priority: optional
Maintainer: Couchbase SDK Team <support@couchbase.com>
Build-Depends: debhelper (>= 9), cmake, pkg-config
Standards-Version: 4.5.0
Vcs-Browser: https://github.com/couchbase/couchbase-cxx-client
Vcs-Git: https://github.com/couchbase/couchbase-cxx-client.git

Package: couchbase-cxx-client
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Couchbase C++ SDK.
 This is the client and protocol library for Couchbase project.

Package: couchbase-cxx-client-tools
Architecture: any
Multi-Arch: same
Section: utils
Depends: couchbase-cxx-client (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Couchbase C++ SDK, command line tools.
 This is the command line tools for the client and protocol library for
 Couchbase project.

Package: couchbase-cxx-client-dev
Architecture: any
Multi-Arch: same
Depends: couchbase-cxx-client (= ${binary:Version}), ${misc:Depends}
Description: Couchbase C++ SDK, development files.
 This is the development files for the client and protocol library for
 Couchbase project.

Package: couchbase-cxx-client-dbg
Architecture: any
Multi-Arch: same
Depends: couchbase-cxx-client (= ${binary:Version}), ${misc:Depends}
Description: Couchbase C++ SDK, debug symbols.
 This is the debug symbols for the client and protocol library for Couchbase
 project.

=== rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake

override_dh_strip:
	dh_strip -pcouchbase-cxx-client-tools -pcouchbase-cxx-client --dbg-package=couchbase-cxx-client-dbg
	dh_strip --remaining-packages

override_dh_auto_configure:
	echo "usr/include/couchbase" \
		> debian/couchbase-cxx-client-dev.install
	echo "usr/include/tao" \
		>> debian/couchbase-cxx-client-dev.install
	echo "usr/lib/$(DEB_HOST_MULTIARCH)/libcouchbase_cxx_client.so" \
		>> debian/couchbase-cxx-client-dev.install
	echo "usr/lib/$(DEB_HOST_MULTIARCH)/libcouchbase_cxx_client_static.a" \
		>> debian/couchbase-cxx-client-dev.install
	echo "usr/lib/$(DEB_HOST_MULTIARCH)/cmake" \
		>> debian/couchbase-cxx-client-dev.install
	echo "usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig" \
		>> debian/couchbase-cxx-client-dev.install
	echo "usr/bin/*" \
		> debian/couchbase-cxx-client-tools.install
	echo "usr/lib/$(DEB_HOST_MULTIARCH)/libcouchbase_cxx_client.so.*" \
		> debian/couchbase-cxx-client.install
	echo "usr/share/doc/tao/json/LICENSE" \
		>> debian/couchbase-cxx-client.install
	echo "usr/share/doc/tao/pegtl/LICENSE" \
		>> debian/couchbase-cxx-client.install
	echo "usr/share/doc/couchbase_cxx_client/LICENSE.txt" \
		>> debian/couchbase-cxx-client.install
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DBUILD_SHARED_LIBS=OFF \
		-DCOUCHBASE_CXX_CLIENT_INSTALL=ON \
		-DCOUCHBASE_CXX_CLIENT_STATIC_BORINGSSL=ON \
		-DCOUCHBASE_CXX_CLIENT_BUILD_EXAMPLES=OFF \
		-DCOUCHBASE_CXX_CLIENT_BUILD_TESTS=OFF \
		-DCOUCHBASE_CXX_CLIENT_BUILD_TOOLS=ON \
		-DCOUCHBASE_CXX_CLIENT_BUILD_STATIC=ON \
		-DCOUCHBASE_CXX_CLIENT_BUILD_SHARED=ON

override_dh_auto_build:
	dh_auto_build
